﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Globalization;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Excel;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using Microsoft.Win32;

namespace WpfExport2Excel
{
  /// <summary>
  /// Interaction logic for Window1.xaml
  /// </summary>
  public partial class Window1 : Window
  {
    private DataPresenterExcelExporter _excelExporter;
    
      public class Class1
    {
        public static List<Class1> BuildExemple()
        {
            Class1 a = new Class1("a");
            a.recursiveChild.Add(a);        //TODO: fix this problem
            a.wantedChild.Add("Very important information");
            List<Class1> list = new List<Class1>();
            list.Add(a);
            return list;
        }

        public Class1(string txt)
        {
            this.Text = txt;
            this.recursiveChild = new List<Class1>();
            this.wantedChild = new List<string>();
        }
        public string Text { get; set; }

        public List<Class1> recursiveChild { get; set; }
        public List<string> wantedChild { get; set; }
    }

    public Window1()
    {
      InitializeComponent();
      _excelExporter = new DataPresenterExcelExporter();
      _excelExporter.InitializeRecord += new EventHandler<InitializeRecordEventArgs>(_excelExporter_InitializeRecord);
      Loaded += Window1_Loaded;
    }


    void _excelExporter_InitializeRecord(object sender, InitializeRecordEventArgs e)
    {
        e.SkipDescendants = true;
    }

    private void Window1_Loaded(object sender, RoutedEventArgs e)
    {
     myGrid.DataSource = Class1.BuildExemple();
    }

    private void Button_Click(object sender, RoutedEventArgs e)
    {
      var saveDialog = new SaveFileDialog
      {
        AddExtension = true,
        DefaultExt = "xlsx",
        Filter = "Excel Worksheets (*.xlsx)|*.xlsx|All Files|*.*"
      };
      if (saveDialog.ShowDialog() == true)
      {
        _excelExporter.Export(myGrid, saveDialog.FileName, WorkbookFormat.Excel2007);
      }

    }
  }
}
